<html>
<head>
<TITLE>MemProf</TITLE>
<LINK REL=STYLESHEET  TYPE="text/css" HREF="bluestripe.css" TITLE="Bluestripe">
</head>

<body>
<H1>MemProf - Profiling and leak detection</H1>

<h2> Introduction </h2>

<p>
 MemProf is a tool for profiling memory usage and finding
 memory leaks. Its two major features are:
</p>

<ul>
<li> It can generate a profile how much memory was
    allocated by each function in your program.</li>

<li> It can scan memory and find blocks that you've
    allocated but are no longer referenced anywhere.</li>
</ul>

<p>
 MemProf works by pre-loading a library to override the
 C library's memory allocation functions and does not
 require you to recompile your program.
</p>

<p>
 One advantage MemProf has over some other similar
 tools that are available is that it has a nice GUI
 frontend and is relatively easy to use.
</p>

<h2> Changes in 0.6.x </h2>
<p>
 The project was forked as the website vanished from the GNOME project
 infrastructure, the current maintainer didn't respond to inquieries and
 memprof is far too young too let it die. The code and releases will
 be hosted here and hopefully one day it will be back on the GNOME
 infrastructure.
</p>

<h2> Changes in 0.6  </h2>
<p>
 The main attraction of 0.6 is that memprof now works again,
 thanks to Michael Meeks. Other new features in the four years since 0.5.1
 release include a rewritten profile module that handles recursion
 better. Also a large number of bugs have been fixed.
</p>

<h2> Changes in 0.5.1 </h2>
<p>
 0.5.1 reworks the way that libmemintercept.so works
 to work a lot better with C++ and with threads.
 (it fixes the infamous "Starter malloc size exceeded" bug)
 It also changes the data structures in the main
 program to use considerably less memory.
</p>

<h2> Changes in 0.5.0 </h2>
<p>
 The big change in this release is a port to GTK+-2.0
 and GNOME-2.0, done by Kristian Rietveld. There are
 also quite a few bug fixes since 0.4.1.
</p>

<h2> Changes in 0.4.1 </h2>
<p>
 This is mostly a bug fix release - it fixes problems with
 recent versions of libc, a crash when using menu accelerators,
 a problem with leaving sockets around, and so forth.
</p>
<p>
 It also includes a bunch more translations and a feature
 to do regular-expression based exclusion of funtions
 from Martin Baulig.
</p>

<h2> Changes in 0.4.0 </h2>
<p>
 The backend in 0.4.0 has been almost totally rewritten
 to support profiling threaded programs and to follow
 the children of programs that fork.
</p>
<p>
 The front end has also been improved in a number of
 ways, translations have been added for 12 languages,
 and numerous bugs have been fixed by myself and others.
</p>
<p>
 Numerous bugs have most likely also been added, so please
 try it out, find them, and let me know.
</p>

<h2> Requirements </h2>

<p>
 For the interface, memprof requires:
</p>

    <ul>
      <li>GTK+ 2.0</li>
      <li>GConf 2.0</li>
      <li>libgnomeui 2.0</li>
      <li>libglade 2.0</li>
    </ul>

    <p>
      These (or newer versions) are all available from <a href="http://ftp.gnome.org/pub/GNOME/sources/">http://ftp.gnome.org/pub/GNOME/sources/</a>
      but if binary packages are available from your distribution,
      it's much easier to install them that way.
    </p>

    <ul>
      <li>libbfd and libiberty from the GNU binutils distribution.
	(Debian users will probably need to install the binutils-dev package)</li>
      <li>Linux (kernel version 2.2 will work better)</li>
      <li>GNU libc (2.0 or or newer will work, but 2.0 may produce warnings
	when compiling. Most recent development has been done with version 2.3.)</li>
    </ul>

<h2> Screenshots </h2>

<ul>
<li> <a href="memprof.jpg">GTK+-1.2 based memprof</a></li>
<li> <a href="memprof-gtk2.jpg">GTK+-2 based memprof (0.5 series)</a></li>
</ul>

<h2> Get the source </h2>

<ul>
<li> You can <a href="http://repo.or.cz/w/memprof.git">browse the sourcecode.</a> or
use git to get the respotitory. <pre>git clone git://repo.or.cz/memprof.git</pre> </li>
<li> <a href="http://www.secretlabs.de/projects/memprof/releases">Current tarballs</a></li>
</ul>

<h2> Frequently asked questions </h2>

    <dl>
      <dt><i>What do the colors mean?</i></dt>
      <dd>Yellow = Allocated<br>
	  Blue = Allocated then freed (high-water-mark)<br>
	  Red = Leaked (after you press the "Leaks" toolbar button)</dd>
      <dt><i>Is there any documentation?</i></dt>
      <dd>Not currently, no. Contributions would be appreciated.<br></dd>
    </dl>

<h2> Mailing List </h2>

<p>
Discussion of using and developing Memprof occurs on
<a href="mailto:memprof-list@gnome.org">memprof-list@gnome.org</a>.
<a href="http://mail.gnome.org/mailman/listinfo/memprof-list">Subscription information</a>
</p>

<h2> Reporting Bugs </h2>

<p>
Bugs should be reported to the GNOME bug tracking system.
(http://bugzilla.gnome.org/, project memprof). You will need to create an
account for yourself.
</p>

<h2> License </h2>

Memprof is Copyright 1999, 2000, 2001, Red Hat, Inc. Copyright 2002,
Kristian Rietveld, Copyright 2009 Holger Hans Peter Freyther, and
licensed under the terms of the
<a href="COPYING">GNU General Public License</a>.

<h2> Other similar tools </h2>

<p>
The technique that MemProf uses for detecting leaks, scanning
memory for pointers, is the basis of the Boehm Garbage
Collector. While the Boehm GC is mostly meant for memory
management, it also has a mode for leak detection
in programs that manually free memory. The package,
unlike MemProf, is highly portable.
</p>

<p>
Keith Packard wrote a memory debugging library (memleak)
included with X that does leak detection. This was
separated out from the X distribution by Jon Christopher
and turned into the standalone
<a href="http://quorum.tamu.edu/jon/gnu/">Debauch</a>
package. From the documentation Debauch seems similar
to MemProf in scope and techniques but somewhat more comprehensive
and portable. It doesn't, however, have MemProf's nice GUI frontend.
</p>

<hr>
<H4>In case of questions contact Holger Freyther<A HREF="mailto:zecke+memprof@secretlabs.de">
&lt;zecke+memprof@secretlabs.de&gt;</A></H4>

</html>
